import { Component } from '@angular/core';
import { RouterOutlet } from '@angular/router';
import { CommentBoxComponent } from "./comment-box/comment-box.component";
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatInputModule } from '@angular/material/input';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ProgressStepperComponent } from "./progress-stepper/progress-stepper.component";
import { Observable, startWith, map } from 'rxjs';
import { MatOptionModule } from '@angular/material/core';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatChipsModule } from '@angular/material/chips';
import { AsyncPipe } from '@angular/common';
import { MatSelectModule } from '@angular/material/select';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatButtonModule } from '@angular/material/button';
import { MatIconModule } from '@angular/material/icon';
import { SelectFilterComponent } from "./select-filter/select-filter.component";
import { GanttComponent, GanttItem } from "./gantt/gantt.component";
import { GrossNetCalculatorComponent } from "./gross-net-calculator/gross-net-calculator.component";
import { GrossNetCalculatorInputDirective } from './gross-net-calculator/gross-net-calculator-input.directive';
import { GrossNetCalculatorToggleButtonComponent } from "./gross-net-calculator/toggle-button/toggle-button.component";

@Component({
  selector: 'app-root',
  imports: [RouterOutlet, MatToolbarModule, GrossNetCalculatorInputDirective, MatIconModule, MatButtonModule, CommentBoxComponent, MatFormFieldModule, MatInputModule, ReactiveFormsModule, ProgressStepperComponent, MatOptionModule, MatSelectModule, MatAutocompleteModule, MatChipsModule, AsyncPipe, FormsModule, SelectFilterComponent, GanttComponent, GrossNetCalculatorComponent, GrossNetCalculatorToggleButtonComponent],
  providers: [GrossNetCalculatorInputDirective],
  templateUrl: './app.component.html',
  styleUrl: './app.component.scss'
})
export class AppComponent {
  title = 'material-mentions';

  selectionList = ["Franz Kaiser", "Melanie Ochse", "Peter Pfeifer", "Hans Wurst", "Hans Ochse", "Max Hintern", "Hansi Hinterseer", "Gustav Gans"];

  form = new FormControl("fdaf <div class=\"mention\">@Franz Kaiser</div><span class=\"focused\">&nbsp;</span>");
  test = '';

  parseComment(comment: FormControl): any {
    if (comment.value)
      return comment.value
  }

  allOptions = ['Apple', 'Banana', 'Orange', 'Pear', 'Grape'];
  filteredOptions = this.allOptions.slice();
  selectedItemsList = new FormControl();

  selectAll(): void {
    this.selectedItemsList.setValue(this.allOptions);
  }

  unselectAll(): void {
    this.selectedItemsList.setValue([]);
  }


  ganttItems: GanttItem[] = [{
    id: '000',
    title: 'Test 1',
    items: [{
      title: '124',
      start: 1743487875,
      duration_sec: 7200,
    }, {
      title: 'F242',
      start: 1743660675,
      duration_sec: 16 * 3600,
    }
    ]
  },
  {
    id: '001',
    title: 'Test 2',
    items: [{
      title: '124',
      start: 1743487875,
      duration_sec: 7200,
    }, {
      title: 'F242',
      start: 1743660675,
      duration_sec: 72000,
    }
    ]
  },
  {
    id: 'dfaf',
    title: 'WeekTest',
    items: [
      { title: '1', start: 1744005600, duration_sec: 72000 },
      { title: '2', start: 1744092000, duration_sec: 72000 },
      { title: '3', start: 1744178400, duration_sec: 72000 },
      { title: '4', start: 1744264800, duration_sec: 72000 },
      { title: '5', start: 1744351200, duration_sec: 72000 },
      { title: '6', start: 1744437600, duration_sec: 72000 },
      { title: '7', start: 1744524000, duration_sec: 72000 }
    ]
  }
  ]
}
